
create or replace function to_json( geodata ) returns json as $$
select json_build_object(
		'latitude',		$1.latitude,
		'longitude',	$1.longitude,
		'altitude',		$1.altitude,
		'roll',			$1.roll,
		'yaw',			$1.yaw,
		'pitch',		$1.pitch,
		'speed',		$1.speed
	);
$$ language sql;


create or replace function to_json( transform2 ) returns json as $$
select json_build_object(
	'a', $1.a,
	'b', $1.b,
	'c', $1.c,
	'd', $1.d,
	'x', $1.x,
	'y', $1.y
);
$$ language sql;


CREATE or replace FUNCTION public.jplatedata(plateid integer) RETURNS text
    LANGUAGE sql
    AS $_$
 select
  E'{ '
  ||'"id": '||coalesce('"'||transform('slashdoublequote',p.id::text)||'"','null')||', '
  ||'"wtime": '||coalesce('"'||transform('slashdoublequote',lib.utcstrftime(wtime))||'"','null')||', '
  ||'"bowtime": '||coalesce('"'||transform('slashdoublequote',lib.ts2us(wtime::timestamp)::text)||'"','null')||', '
  ||'"ctime": '||coalesce('"'||transform('slashdoublequote',lib.utcstrftime(ctime))||'"','null')||', '
  ||'"boctime": '||coalesce('"'||transform('slashdoublequote',lib.ts2us(ctime::timestamp)::text)||'"','null')||', '
  ||'"stime": '||coalesce('"'||transform('slashdoublequote',lib.utcstrftime(stime))||'"','null')||', '
  ||'"bostime": '||coalesce('"'||transform('slashdoublequote',lib.ts2us(stime::timestamp)::text)||'"','null')||', '
  ||'"etime": '||coalesce('"'||transform('slashdoublequote',lib.utcstrftime(etime))||'"','null')||', '
  ||'"boetime": '||coalesce('"'||transform('slashdoublequote',lib.ts2us(etime::timestamp)::text)||'"','null')||', '
  ||'"eventspec": '||coalesce('"'||transform('slashdoublequote',p.eventspec::text)||'"','null')||', '
  ||'"channel": {'
  ||'"channel": '||coalesce('"'||transform('slashdoublequote',p.channel::text)||'"','null')||', '
  ||'"name": '||coalesce('"'||transform('slashdoublequote',c.name::text)||'"','null')||', '
  ||'"description": '||coalesce('"'||transform('slashdoublequote',c.description::text)||'"','null')||' '
  ||'}, '
  ||'"media_id": '||coalesce('"'||transform('slashdoublequote',p.media_id::text)||'"','null')||', '
  ||'"rect": {'
  ||'"left": '||coalesce('"'||transform('slashdoublequote',p.rect_left::text)||'"','null')||', '
  ||'"top": '||coalesce('"'||transform('slashdoublequote',p.rect_top::text)||'"','null')||', '
  ||'"right": '||coalesce('"'||transform('slashdoublequote',p.rect_right::text)||'"','null')||', '
  ||'"bottom": '||coalesce('"'||transform('slashdoublequote',p.rect_bottom::text)||'"','null')||' '
  ||'}, '
  ||'"number": '||coalesce('"'||transform('slashdoublequote',p."number")||'"','null')||', '
  ||'"country": '||coalesce('"'||transform('slashdoublequote',p.country::text)||'"','null')||', '
  ||'"numtype": '||coalesce('"'||transform('slashdoublequote',p.numtype::text)||'"','null')||', '
  ||'"iodir": '||coalesce('"'||transform('slashdoublequote',p.iodir::text)||'"','null')||', '
  ||'"direction": '||coalesce('"'||transform('slashdoublequote',p.direction::text)||'"','null')||', '
  ||'"post": {'
  ||'"guid": '||coalesce('"'||transform('slashdoublequote',p.post_id::text)||'"','null')||', '
  ||'"name": '||coalesce('"'||transform('slashdoublequote',s.name::text)||'"','null')||' '
  ||'}, '
  ||'"velocity": '||coalesce('"'||transform('slashdoublequote',p.velocity::text)||'"','null')||', '
  ||'"validity": '||coalesce('"'||transform('slashdoublequote',p.validity::text)||'"','null')||', '
  ||'"geodata": '||coalesce('"'||to_json(p.geodata)||'"','null')||', '
  ||'"scrollid": '||coalesce('"'||transform('slashdoublequote',p.scrollid::text)||'"','null')||', '
  ||'"scrollts": '||coalesce('"'||transform('slashdoublequote',p.scrollts::text)||'"','null')||', '
  ||'"comment": '||coalesce('"'||transform('slashdoublequote',p.comment)||'"','null')||', '
  ||'"alarm_type": '||coalesce('"'||transform('slashdoublequote',p.alarm_type::text)||'"','null')||', '
  ||'"alarm_state": '||coalesce('"'||transform('slashdoublequote',p.alarm_state::text)||'"','null')||' '
  ||coalesce(','||jlistinfodata(p.number)||'','')||' '
  ||'} '
  from platear p, post s, channel c 
  where s.guid = p.post_id and c.channel = p.channel and p.id = $1;
$_$;


CREATE or replace FUNCTION jlistinfodata(number text) RETURNS text
    LANGUAGE sql
    AS $_$
select E'"listinfo": {}'::text;
$_$;



