CREATE or replace FUNCTION platear_postfactum_saveimg(new platear, old platear, op character varying) RETURNS character varying
    LANGUAGE plpgsql
    AS $$
begin
	if _o('platear_saveimg_as_is')::boolean then
		perform public.plate_save(new.id);
	end if;	
	return 'OK';
end;
$$;


CREATE or replace FUNCTION platear_postfactum_savemeta(new platear, old platear, op character varying) RETURNS character varying
    LANGUAGE plpgsql
    AS $$
begin
	if _o('platear_savemeta_as_is')::boolean then
		perform public.meta_save(new.id);
	end if;	
	return 'OK';
end;
$$;


CREATE or replace FUNCTION plate_save(ipid integer) RETURNS text
    LANGUAGE plpythonu
    AS $$ 
import re
import unicodedata

try:
    rvo = plpy.execute("""
        select
            _o('platear_saveimg_as_is')::boolean as doit,
            _o('platear_saveimg_crop_plate')::boolean as crop,
            _o('platear_saveimg_frame_noplate')::boolean as save_frame,
            _o('platear_saveimg_slur_frame_osroi')::boolean as osroi_slur,
            _o('platear_saveimg_crop_frame_osroi')::boolean as osroi_crop
    """, 1)
except Exception as ex:
    return 'ERROR{bad opt} ' + str(ex)

try:
    rvp = plpy.execute("select p.*,  t.name as pn, c.name as cn, "
                       "(p.number notnull and not p.number = '') as hasplate "
                       "from platear p, channel c, post t where "
                       "t.guid = p.post_id and c.post = p.post_id and "
                       "c.channel = p.channel and p.id = {0} ".format(
        ipid), 1)
except Exception as ex:
    return 'ERROR{bad platear} ' + str(ex)

sb = dict()
sb['pi'] = str(rvp[0]['post_id'])
sb['ci'] = str(rvp[0]['channel'])
sb['pn'] = re.sub(r"\p{Mn}", "",
                  unicodedata.normalize("NFKD",
                                        (rvp[0]['pn']).decode('utf-8')))
sb['cn'] = re.sub(r"\p{Mn}", "",
                  unicodedata.normalize("NFKD",
                                        (rvp[0]['cn']).decode('utf-8')))
sb['ri'] = str(ipid)
sb['nn'] = re.sub(r"\p{Mn}", "",
                  unicodedata.normalize("NFKD",
                                        (rvp[0]['number']).decode('utf-8')))
sb['mi'] = str(rvp[0]['media_id'])

if rvp[0]['hasplate']:
    if rvo[0]['crop']:
        try:
            rvr = plpy.execute("""select lib.bytea_save_formatted (
                (recrop_plate({0},
                    _o('platear_saveimg_crop_plate_margins')::float8[],
                    _o('platear_saveimg_crop_plate_sizes')::integer[],
                    true)).data,
                _o('platear_saveimg_path_plate'),
                E'{1}',
                null ) as res""".format(ipid,
                                        str(sb).replace("'", "''")), 1)
            if rvr[0]['res'] is not None and rvr[0]['res'] > 0:
                return 'OK'
            return 'ERROR{on crop}'
        except Exception as ex:
            return 'ERROR{on save crop} ' + str(ex)
else:
    if not rvo[0]['save_frame']:
        return 'NOTICE{skip noplate}'

if rvo[0]['osroi_slur'] or rvo[0]['osroi_crop']:
    vx = None
    try:
        rvm = plpy.execute("select *, (clock_timestamp() - changed) > "
                           "_so('rectification_opt_timeout')::interval as "
                           "expared from service.rectification_opt "
                           "where post = {0} and channel = {1}"
                           .format(rvp[0]['post_id'], rvp[0]['channel']),
                           1)
        if rvm.nrows() < 1 or rvm[0]['expared']:
            plpy.execute("select service.rectification_makeopt()", 0)
            rvm = plpy.execute("select *, (clock_timestamp() - changed) > "
                               "_so('rectification_opt_timeout')::interval "
                               "as expared from service.rectification_opt "
                               "where post = {0} and channel = {1}"
                               .format(rvp[0]['post_id'],
                                       rvp[0]['channel']),
                               1)
        if rvm.nrows() > 0:
            opt = eval(rvm[0]['optstring'])
            if 'shVertexes' in opt:
                vx = opt['shVertexes']
    except Exception as ex:
        plpy.notice('ERROR:SP:VX: ' + str(ex))

    if vx is not None:
        try:
            rvr = plpy.execute("""select lib.bytea_save_formatted (
                (lib.slur(plate_image_get({0},'frame'),
                    E'{1}',
                    _o('platear_saveimg_invr_frame_osroi')::boolean,
                    _o('platear_saveimg_crop_frame_osroi')::boolean,
                    _o('platear_saveimg_slur_frame_osroi')::boolean
                    )).data,
                _o('platear_saveimg_path_frame'),
                E'{2}',
                null ) as res""".format(rvp[0]['media_id'],
                                        str(vx).replace("'", "''"),
                                        str(sb).replace("'", "''")),
                               1)
            if rvr[0]['res'] is not None and rvr[0]['res'] > 0:
                return 'OK'
            return 'ERROR{on crop}'
        except Exception as ex:
            return 'ERROR{on save frame slur} ' + str(ex)
try:
    rvr = plpy.execute("""select lib.bytea_save_formatted (
        plate_image_get({0},'frame'),
        _o('platear_saveimg_path_frame'),
        E'{1}',
        null ) as res""".format(rvp[0]['media_id'],
                                str(sb).replace("'", "''")),
                       1)
    if rvr[0]['res'] is not None and rvr[0]['res'] > 0:
        return 'OK'
    return 'ERROR{on frame}'
except Exception as ex:
    return 'ERROR{on save frame} ' + str(ex)
$$;


CREATE or replace FUNCTION meta_save(ipid integer) RETURNS text
    LANGUAGE plpythonu
    AS $$ 
import re
import unicodedata

try:
    rvp = plpy.execute("select p.*,  t.name as pn, c.name as cn, "
                       "(p.number notnull and not p.number = '') as hasplate"
                       " from platear p, channel c, post t"
                       " where t.guid = p.post_id and c.post = p.post_id and "
                       "c.channel = p.channel and p.id = {0} ".format(ipid), 1)
except Exception as ex:
    return 'ERROR{bad platear} ' + str(ex)

sb = dict()
sb['pi'] = str(rvp[0]['post_id'])
sb['ci'] = str(rvp[0]['channel'])
sb['pn'] = re.sub(r"\p{Mn}", "",
                  unicodedata.normalize("NFKD",
                                        (rvp[0]['pn']).decode('utf-8')))
sb['cn'] = re.sub(r"\p{Mn}", "",
                  unicodedata.normalize("NFKD",
                                        (rvp[0]['cn']).decode('utf-8')))
sb['ri'] = str(ipid)
sb['nn'] = re.sub(r"\p{Mn}", "",
                  unicodedata.normalize("NFKD",
                                        (rvp[0]['number']).decode('utf-8')))
sb['mi'] = str(rvp[0]['media_id'])

try:
    rvr = plpy.execute("""select lib.bytea_save_formatted (
        jplatedata({0}),
        _o('platear_savemeta_path'),
        E'{1}',
        null ) as res""".format(ipid, str(sb).replace("'", "''")), 1)
    if rvr[0]['res'] is not None and rvr[0]['res'] > 0:
        return 'OK'
    return 'ERROR{on meta}'
except Exception as ex:
    return 'ERROR{on save meta} ' + str(ex)
$$;
