create or replace function channel_insert_t() returns trigger as $$
declare
	im text;
	imtype text;
	st text;
	rt text;
	mst text;
    s record;
    r record;
begin
	for imtype in select unnest(array['frame','body','plate','stampedframe','stampedbody']) loop
		if imtype = 'frame' then
			im := 'frame';
		else
			im := _o('plateimage_store_image_'||imtype);
			if im isnull or im = '' then continue; end if;
		end if;	
		select into s * from plate_mediastore where post = new.post and channel = new.channel and image = im;
		if not found then
			st := im||':'||new.channel::text||'@'||new.post::text;	
			insert into plate_mediastore (post,channel,image,store,minage,maxage) values (
				new.post,
				new.channel,
				im,
				st,
				_o('plateimage_store_age_min_'||imtype)::interval,
				_o('plateimage_store_age_max_'||imtype)::interval
			) returning * into s;
		end if;
        st := s.store;
        select into r * from binfs.store where name = st;
		if not found then
			rt := lib.pathjoin(_o('plateimage_store_root'),new.post::text,new.channel::text,im);
			if not binfs.test(rt) then
				perform core.log('create store','error','Can`t access root dir: '||rt);
				raise 'Error access BINFS root dir %', rt;
				return null;
			end if;
			insert into binfs.store (name,root,class,opt) values (
				st,
				rt,
				_o('plateimage_store_class'),
				_o('plateimage_store_opt')
			) returning * into r;
		end if;

        perform public.mediastore_reconf(overlay(s.post::text placing trim(to_char(s.channel,'000000')) from 31),
            r.root::text, r.class::text, r.opt::text, extract(epoch from s.minage)::int, extract(epoch from s.maxage)::int); 

	end loop;
	return new;	
end;
$$ language plpgsql;




