CREATE or replace FUNCTION channel_restat(ipost uuid, ichannel integer, itag text DEFAULT NULL::text) RETURNS void
    LANGUAGE plpgsql
    AS $$
declare
	sect text;
	pool integer;
	cnt integer;
	r record;
	mx float8 := 0;
	my float8 := 0;
	ms float8 := 0;
	n integer := 0;
	ss float8 := 0.0;
	sr float8 := 0.0;
	_box box;
begin
	sect := ichannel::text||'@'||ipost::text;
	
	select into pool core.getopt(sect,'pool')::integer;
	if pool isnull then
		select into cnt max(id) - _o('platear_stat_minpool')::integer from platear where post_id = ipost and channel = ichannel;
		if cnt isnull or cnt < 0 then return; end if;
		perform core.putopt ( sect, 'pool', max(id)::text, '0', 'integer', 'platestat', 999 ) from platear where post_id = ipost and channel = ichannel;
	else
		select into cnt max(id) - pool - _o('platear_stat_pool_delta')::integer from platear;	
		if cnt < 0 then return; end if;
		perform core.setopt(sect,'pool',max(id)::text) from platear where post_id = ipost and channel = ichannel;
	end if;

	if itag = 'plate.deviation' or itag isnull then
		for r in select * from platear where post_id = ipost and channel = ichannel order by id desc limit _o('platear_stat_maxpool')::integer loop
			_box := box(point(r.rect_left::float8,r.rect_top::float8),point(r.rect_right::float8,r.rect_bottom::float8));
			ms := ms + width(_box)::float8;
			mx := mx + (point(_box))[0]::float8;
			my := my + (point(_box))[1]::float8;
			n := n + 1;
		end loop;
			ms := ms / n::float8; mx := mx / n::float8; my = my / n::float8;
			n := 0;
		for r in select * from platear where post_id = ipost and channel = ichannel order by id desc limit _o('platear_stat_maxpool')::integer loop
			_box := box(point(r.rect_left::float8,r.rect_top::float8),point(r.rect_right::float8,r.rect_bottom::float8));
			ss := ss + (ms - width(_box)::float8)*(ms - width(_box)::float8);
			sr := sr + (point(_box) <-> point(mx::numeric,my::numeric))*(point(_box) <-> point(mx::numeric,my::numeric));
			n := n + 1;
		end loop;
			ss := sqrt(ss / n::float8);
			sr := sqrt(sr / n::float8);
		if not exists ( select true from core.opt where section = sect and key = 'stat.size.mean') then
			perform core.putopt(sect,'stat.size.mean',ms::text,'0','numeric','platestat',999);
		else
			perform core.setopt(sect,'stat.size.mean',ms::text);
		end if;	
		if not exists ( select true from core.opt where section = sect and key = 'stat.size.deviation') then
			perform core.putopt(sect,'stat.size.deviation',ss::text,'0','numeric','platestat',999);
		else
			perform core.setopt(sect,'stat.size.deviation',ss::text);
		end if;	
		if not exists ( select true from core.opt where section = sect and key = 'stat.position.mean.x') then
			perform core.putopt(sect,'stat.position.mean.x',round(mx)::text,'0','numeric','platestat',999);
		else
			perform core.setopt(sect,'stat.position.mean.x',round(mx)::text);
		end if;	
		if not exists ( select true from core.opt where section = sect and key = 'stat.position.mean.y') then
			perform core.putopt(sect,'stat.position.mean.y',round(my)::text,'0','numeric','platestat',999);
		else
			perform core.setopt(sect,'stat.position.mean.y',round(my)::text);
		end if;	
		if not exists ( select true from core.opt where section = sect and key = 'stat.position.deviation') then
			perform core.putopt(sect,'stat.position.deviation',sr::text,'0','numeric','platestat',999);
		else
			perform core.setopt(sect,'stat.position.deviation',sr::text);
		end if;	
	end if;

end;
$$;
