create or replace function public.estimatch( idata json, ipattern json, out ematch boolean, out elen integer ) as $$
import json, operator
pattern = json.loads(ipattern) if ipattern else dict()
data = json.loads(idata) if idata else dict()
elen = 0
ematch = True
operators = {
    'lt': operator.lt,
    '<' : operator.lt,
    'le': operator.le,
    '<=': operator.le,
    'eq': operator.eq,
    '==': operator.eq,
    'ne': operator.ne,
    '<>': operator.ne,
    'ge': operator.ge,
    '>=': operator.ge,
    'gt': operator.gt,
    '>' : operator.gt
}
for attr,body in pattern.iteritems():
    if type(body) <> list or len(body) <> 2:
        raise ValueError('Invalid pattern body for ' + attr)
    [op,val] = body
    if not op in operators:
        raise ValueError('Invalid pattern body operator ' + op)
    if attr in data:
        res = operators[op](data[attr], val)
        if res == True:
            elen += 1
        else:
            ematch = False
            break
    else:
        ematch = False
        break
return {"ematch": ematch, "elen": elen}    
$$ language plpythonu;

create or replace function public.estimate( iname varchar, idata json default null ) returns varchar as $$
    select 
        value 
    from 
        estimates,estimatch($2,pattern) 
    where 
        name = $1 and ematch 
    order by elen desc limit 1;
$$ language sql immutable;

