
create or replace function public.mediastore_reconf( iuuid text, iroot text, iclass text, iopt text, iminage int, imaxage int ) returns void as $$
import os, sys, json, hashlib
from datetime import datetime
param = { 
    "uuid": iuuid, 
    "ctime": datetime.utcnow().isoformat(), 
    "root": iroot, 
    "class": iclass, 
    "opt": eval(iopt), 
    "minage": "%ds" % (iminage), 
    "maxage": "%ds" % (imaxage)
}
paramchk = {}
rv = plpy.execute("select _bo('path_timestamp_as_utc')::boolean as pt, _bo('meta_page_size')::int as ps",1)
if rv.nrows() > 0:
    param['ts_to_utc'] = rv[0]['pt']
    param['meta_page_size'] = rv[0]['ps']
buf = json.dumps(param)
sha = hashlib.sha256(buf).hexdigest()
size = len(buf)
res = ( 'SIZE' in paramchk 
    and paramchk['SIZE'] == size 
    and 'SHA256' in paramchk 
    and paramchk['SHA256'] == sha )
paramchk['SHA256'] = sha
paramchk['SIZE'] = size 
paramchk['GUID'] = param['uuid']
paramchk['UP'] = datetime.utcnow().isoformat()
if not os.path.exists(iroot):
    os.makedirs(iroot)
with open(os.path.join(iroot,'__binfs'),'w') as _fconf, open(os.path.join(iroot,'__binfs.check'),'w') as _fcheck:
    json.dump(param,_fconf,sort_keys=True, indent=4, ensure_ascii=False)
    json.dump(paramchk,_fcheck,sort_keys=True, indent=4, ensure_ascii=False)
$$ language plpythonu;


create or replace function public.mediastore_reconf_t() returns trigger as $$
begin
    perform public.mediastore_reconf(overlay(q.post::text placing trim(to_char(q.channel,'000000')) from 31),
        q.root::text, q.class::text, q.opt::text, extract(epoch from q.minage)::int, extract(epoch from q.maxage)::int) from (
        select * from
        public.plate_mediastore m 
            join binfs.store s on s.name = m.store
        where 
            m.post = NEW.post and
            m.channel = NEW.channel and
            m.image = NEW.image
     ) q;      
    return NEW; 
end;
$$ language plpgsql;

