
create or replace function public.plate_titledata( ipid bigint ) returns json as $$
declare
	_r record;
	_res json := '{}'::json;
begin
	
	select into _r
		coalesce(_o('platear_subtitle_opt')::json,'{}'::json) as _titleopt,
		to_json(coalesce(t.name,'post')||' '||lib.geoformat(p.geodata,'dms')) as postnamegd,
		to_json(to_char(p.ctime at time zone _o('local_timezone'),coalesce(_o('platear_ctime_format')::text,'DD-MM-YYYY HH24:MI:SS.MS'))) as moment,
		to_json(coalesce(p.velocity,0)::text||'('||coalesce(p.velocity-p.int0,0)::text||')') as speedext,
		to_json(coalesce(t.name,'post')) as postname,
		coalesce(t.param,'{}'::json) as postparam,
		to_json(coalesce(c.name,'')) as channelname,
		coalesce(c.param,'{}'::json) as channelparam,
		to_json(coalesce(lib.geoformat(p.geodata,'dms'),'')) as geodata,
		to_json(coalesce(p.velocity,0)::text) as speedval,
		to_json(coalesce(p.velocity-p.int0,0)::text) as speedlimit,
		to_json(coalesce(p.number,'')::text) as number,
		to_json(_str('captions',(case when p.direction = 11 then 'dir.app' when p.direction = 12 then 'dir.rec' else 'dir.unk' end))) as direction
		from
		platear p, post t, channel c
		where
		p.id = ipid and t.guid = p.post_id and c.post = p.post_id and c.channel = p.channel
		limit 1;
	
	if found then _res := row_to_json(_r); end if;
	
	return _res;
end;
$$ language plpgsql;

