
create or replace function public.plate_to_json ( p platear ) returns json as $$
begin
return json_build_object (
	'plate',
	json_build_object(
		'exact_rect',	json_build_array(p.rect_left,p.rect_top,p.rect_right,p.rect_bottom),
		'text',			p.number,
		'country',		p.country,
		'validity',		p.validity,
		'type',			p.numtype
	),
	'image', 			p.media_id,
	'direction', 		p.direction,
	'bestts', 			lib.ts2us(p.ctime),
	'guid',				p.guid::text,
	'speed',			coalesce(p.velocity,0),
	'speedlimit',		coalesce(p.velocity-p.int0,0),
	'id',				p.id,
	'geodata',
	json_build_object(
		'latitude',		to_char((p.geodata).latitude,'99D9999'),
		'longitude',	to_char((p.geodata).longitude,'99D9999'),
		'altitude',		to_char((p.geodata).altitude,'99D9999'),
		'roll',			to_char((p.geodata).roll,'99D9999'),
		'yaw',			to_char((p.geodata).yaw,'99D9999'),
		'pitch',		to_char((p.geodata).pitch,'99D9999'),
		'speed',		to_char((p.geodata).speed,'99D9999')
	)
);
end;
$$ language plpgsql;

