CREATE or replace FUNCTION platear_filter_t() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
declare
	v text;
	d text;
	e integer;
begin
	if _o('platear_filter_on_insert')::boolean then
		select into v,d verdict,diagnosis from plate_proposition(new.ctime,new.post_id,new.channel,new.direction,new.number,new.rect_left,new.rect_top,new.rect_right,new.rect_bottom);
		if v is distinct from 'ACCEPT' then
			NEW.validity := -1;
			NEW.eventspec := NEW.eventspec | 8;
			NEW.alarm_type := -1;
			NEW.processing := NEW.processing | _i('platear.processed','check');
			NEW.status := NEW.status | _i('platear.status','filtered');
			NEW.comment := NEW.comment || '<filtered diagnosis="'||d||'"/>';
			perform core.log('platear','warning','DECLINED['||new.id::text||'] as: '||d);
		end if;
	end if;	
	return NEW;
end;
$$;
