create or replace function platear_notify_t () returns trigger as $$
declare
	evt json;
	chg text[];
begin
	if TG_OP = 'UPDATE' then
		if  _o('platear_notify_on_update')::boolean then
			if new.number is distinct from old.number then chg := array_append(chg,'number'); end if;
			if new.media_id is distinct from old.media_id then chg := array_append(chg,'media'); end if;
			if new.alarm_type is distinct from old.alarm_type then chg := array_append(chg,'alarm'); end if;
			select into evt json_build_object('cause','update','post',new.post_id,'channel',new.channel,'id',new.id,'guid',new.guid::text,'ctime',extract(epoch from new.ctime),'number',new.number,'alarm',new.alarm_type,'changes',array_to_json(chg));
			if _o('platear_notify_channel_pg') is distinct from '' then perform pg_notify(_o('platear_notify_channel_pg'), evt::text); end if;
			if _o('platear_notify_channel_os') is distinct from '' then perform notify_push(_o('platear_notify_channel_os'),new.channel::text||'@'||new.post_id::text,'plate.updated',evt::text); end if;
		end if;
	else
		if  _o('platear_notify_on_insert')::boolean then
			select into evt json_build_object('cause','insert','post',new.post_id,'channel',new.channel,'id',new.id,'guid',new.guid::text,'ctime',extract(epoch from new.ctime),'number',new.number,'alarm',new.alarm_type);
			if _o('platear_notify_channel_pg') is distinct from '' then perform pg_notify(_o('platear_notify_channel_pg'), evt::text); end if;
			if _o('platear_notify_channel_os') is distinct from '' then perform notify_push(_o('platear_notify_channel_os'),new.channel::text||'@'||new.post_id::text,'plate.inserted',evt::text); end if;
		end if;
	end if;
	return NEW;
end;
$$ language plpgsql;
