CREATE or replace FUNCTION platear_postfactum_check(new platear, old platear, op character varying) RETURNS character varying
    LANGUAGE plpgsql
    AS $_$
declare
	r record;
	sl integer;
	sm integer;
begin
	if op = 'UPDATE' and new.number = old.number then return 'OK'; end if;
	if _o('platear_check_speedlimit')::boolean then	
		sl := estimate('speedlimit' ,json_build_object('post',new.post_id,'channel',new.channel,'lane',new.lane,'numtype',new.numtype));
		sm := estimate('speedmargin',json_build_object('post',new.post_id,'channel',new.channel,'lane',new.lane,'numtype',new.numtype));
		if (sl isnull or sm isnull) and _o('platear_common_speedlimit')::integer > 0 then
			sl := _o('platear_common_speedlimit')::integer;
			sm := _o('platear_common_speedmargin')::integer;
		end if;	
		if not ( sl is null or sm is null ) 
			and not new.velocity is null 
			and new.velocity > 0 
			and sl > 0 
			and new.velocity > sl + sm
		then
				update platear set 
					alarm_type = alarm_type | _i('mask.issue.type','speedviolation'), 
					alarm_state = 1, 
					status = status | _i('mask.platear.status','violation') 
				where id = new.id;
				perform pg_notify('alarm', ('id=' || new.id));
				insert into plate_hash values (new.id,new.guid,'speedviolation',(new.velocity-sl)::text);
		end if;
		if not sl is null and sl > 0 then
				update platear set int0 = (new.velocity-sl) where id = new.id;
		end if;		
	end if;
	if _o('platear_check_watchlist')::boolean then
		-- todo
	end if;
	return 'OK';
end;
$_$;

