CREATE OR REPLACE FUNCTION platear_postfactum_crop("new" platear, "old" platear, op character varying)
  RETURNS character varying AS
$BODY$
declare
	bodymargin float8[];
	bodysizes integer[];
	platemargin float8[];
	platesizes integer[];
	rect integer[];
	titledata text;
	tti bytea;
	res text;
begin
	if new.media_id isnull then return 'OK'; end if;
	if op = 'UPDATE' and (
		(new.rect_top, new.rect_right, new.rect_bottom, new.rect_left) 
		is not distinct from 
		(old.rect_top, old.rect_right, old.rect_bottom, old.rect_left)
		and new.media_id is not distinct from old.media_id
	) 
	then
		perform core.log('platear-recrop','info','update unchanged rect: skipped ' || new.id::text || ' ' || new.eventspec::text || ' ' || new.number || ' ' || new.comment);
		return 'SKIP:RECT';
	end if;
	
	select into res public.plate_recrop (
		new.id
	);	
	
	if not res = 'OK' then
		perform core.log('_recropall','error','crop error: '||res);
		return 'ERROR:CROP';
	end if;
	
	return 'OK';
end;
$BODY$
  LANGUAGE plpgsql;
