CREATE or replace FUNCTION platear_postfactum_t() RETURNS trigger
    LANGUAGE plpgsql
    AS $_$
declare
	r record;
	res varchar;
	st timestamptz;
begin
	for r in 
		select * 
		from public.plate_postfactum 
		where 
			enabled and 
			(
				(TG_OP = 'INSERT' and oninsert) or 
				(TG_OP = 'UPDATE' and onupdate)
			) and 
			section = 'platear' 
	loop
		begin
			st := clock_timestamp();
			execute 
				'select '||r.handler||'($1,$2,$3)' 
			into 
				res
			using
				NEW,
				(case when TG_OP='INSERT' then NEW else OLD end),
				TG_OP;
			if upper(res) <> 'OK' then perform core.log('postfactum:'||r.handler,'error',res); end if;	
		exception when others then
			perform core.log('postfactum:'||r.handler,'error',E'ERROR:{state:'||SQLSTATE||E',errm:'||SQLERRM||E'}');
		end;	
	end loop;	
	return NEW;
end; $_$;


