CREATE TABLE if not exists channel
(
  id serial,
  post uuid NOT NULL,
  channel integer NOT NULL default 0,
  name varchar(256),
  description text,
  param json,
  CONSTRAINT channel_pkey PRIMARY KEY (id)
);
COMMENT ON TABLE channel IS 'Перечень всех существующих каналов на всех постах';
COMMENT ON COLUMN channel.id IS 'id канала';
COMMENT ON COLUMN channel.post IS 'guid поста, к которому относится канал';
COMMENT ON COLUMN channel.channel IS 'номер канала';
COMMENT ON COLUMN channel.name IS 'название канала';
COMMENT ON COLUMN channel.description IS 'описание, что это за устройстово на этом канале/ где находится';
COMMENT ON COLUMN channel.param IS ' json co всеми данными, параметрами и настройками данного канала';

DO $$
BEGIN
IF to_regclass('public.i_post_channel') IS NULL THEN
    CREATE UNIQUE INDEX i_post_channel ON channel using btree (post,channel);
END IF;
END$$;
